---
title: Custom Navigation Buttons
product: Form Library
description: Learn how to easily add a new navigation button to a form by using the addNavigationItem() method. View a free demo for JavaScript with a ready-to-use code snippet to learn more. Customize your forms and improve user experience with SurveyJS.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/add-custom-navigation-button/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Custom Navigation Buttons (Vanilla JS)

A survey displays a set of navigation buttons for respondents to start and end the survey, switch between survey pages, or preview answers. This example demonstrates how to add a custom navigation button that performs any required action.

## Configure a Custom Navigation Button

To add a custom button to your survey, call the [`addNavigationItem`](/form-library/documentation/api-reference/survey-data-model#addNavigationItem) method on a [`SurveyModel`](/form-library/documentation/api-reference/survey-data-model) instance. This method accepts an [`IAction`](/form-library/documentation/api-reference/iaction) object whose properties configure the button. Assign a unique string value to the [`id`](/form-library/documentation/api-reference/iaction#id) property and a button caption to the [`title`](/form-library/documentation/api-reference/iaction#title) property. Use the [`action`](/form-library/documentation/api-reference/iaction#action) property to specify the function this button should execute. This demo adds a custom "Clear Page" button that clears question values on the current page.

## Position a Custom Navigation Button

Navigation buttons are ordered according to their [`visibleIndex`](/form-library/documentation/api-reference/iaction#visibleIndex) values. The following table lists the `visibleIndex` values of built-in buttons:

| Navigation Button | `visibleIndex` |
| ----------------- | -------------- |
| Start | 10 |
| Previous Page | 20 |
| Next Page | 30 |
| Preview | 40 |
| Complete | 50 |

To insert a custom button before, after, or between two other buttons, assign a corresponding `visibleIndex` value to this button. If you do not specify `visibleIndex`, your button will be added to the end.

You can also position a button using CSS. Navigation controls are `<button>` elements wrapped in `<div>` elements. Create a CSS class that positions the `<div>` the way you need and assign the class name to the [`css`](/form-library/documentation/api-reference/iaction#css) property of the `IAction` object when you add the button. In this demo, the "Clear Page" button is aligned to the left using the `.nav-button-div` CSS class.

## Customize Button Appearance Using CSS

To style a custom button, define one or more CSS classes for the inner `<button>` element. The button also contains a nested `<span>` element for its label text. Assign one or more space-separated class names to the [`innerCss`](/form-library/documentation/api-reference/iaction#innerCss) property of the `IAction` object.

This demo shows how to override background and font colors for a custom button in normal and hover states.

## Localize the Button Text

Localization allows you to translate a custom button's caption to different languages. To localize the button text, you need to get objects with translations for each target locale and add a custom property to them. This property should contain a button caption for a specific locale. To apply the translations, assign the custom property's name to the `locTitleName` property of the `IAction` object. Make sure not to specify the `title` property in this case. Refer to the commented-out lines in the code listing for an example.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
.nav-button-div {
    margin-left: auto; 
    margin-right: 0;
}

.nav-button {
    background-color: #ff9814;
}

.nav-button:hover {
    background-color: #f28a05;
}

.nav-button span,
.nav-button:hover span {
  color: #ffffff;
}
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
// Uncomment the following line if you want to localize the custom button text 
//import { getLocaleStrings } from "survey-core";
//import "survey-core/survey.i18n";

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
// Uncomment the following lines if you want to localize the custom button text 
// const enTranslations = getLocaleStrings("en");
// const frTranslations = getLocaleStrings("fr");
// enTranslations.clearPage = "Clear Page";
// frTranslations.clearPage = "Effacer la page";

survey.addNavigationItem({
    id: "sv-nav-clear-page",
    // To set the button text, use the `title` property  if you don't use localization:
    title: "Clear Page",
    // ... or the `locTitleName` property if you do use localization:
    // locTitleName: "clearPage",
    action: () => {
        survey.currentPage.questions.forEach((question) => {
            question.value = undefined;
        });
    },
    css: "nav-button-div",
    innerCss: "nav-button"
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "Patient Assessment Form",
  "pages": [
   {
    "name": "Patient information",
    "elements": [
     {
      "type": "panel",
      "name": "patient-information",
      "elements": [
       {
        "type": "text",
        "name": "first-name",
        "title": "First name"
       },
       {
        "type": "text",
        "name": "last-name",
        "startWithNewLine": false,
        "title": "Last name"
       },
       {
        "type": "text",
        "name": "ssn",
        "title": "Social Security number",
        "requiredErrorText": "You SSN must be a 9-digit number.",
        "validators": [
         {
          "type": "regex",
          "text": "Your SSN must be a 9-digit number",
          "regex": "^(?!0{3})(?!6{3})[0-8]\\d{2}-?(?!0{2})\\d{2}-?(?!0{4})\\d{4}$"
         }
        ],
        "maxLength": 9
       },
       {
        "type": "text",
        "name": "birthdate",
        "startWithNewLine": false,
        "title": "Date of birth",
        "inputType": "date",
        "maxValueExpression": "today()"
       },
       {
        "type": "text",
        "name": "concerns",
        "title": "List any concerns you want to talk about during your visit"
       }
      ]
     }
    ],
    "title": "Patient information"
   },
   {
    "name": "Health history",
    "elements": [
     {
      "type": "panel",
      "name": "health-history",
      "elements": [
       {
        "type": "boolean",
        "name": "diabetes",
        "startWithNewLine": false,
        "title": "Do you have diabetes?"
       },
       {
        "type": "boolean",
        "name": "high-blood-pressure",
        "startWithNewLine": false,
        "title": "High blood pressure?"
       },
       {
        "type": "boolean",
        "name": "high-cholesterol",
        "startWithNewLine": false,
        "title": "High cholesterol?"
       },
       {
        "type": "comment",
        "name": "other-health-conditions",
        "title": "Do you have other health conditions?",
        "maxLength": 300
       }
      ]
     }
    ],
    "title": "Health history"
   },
   {
    "name": "Social history",
    "elements": [
     {
      "type": "panel",
      "name": "social-history",
      "elements": [
       {
        "type": "panel",
        "name": "smoking",
        "elements": [
         {
          "type": "radiogroup",
          "name": "cigarettes",
          "title": "Do you smoke cigarettes?",
          "choices": [
           {
            "value": "never",
            "text": "Never"
           },
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "quit",
            "text": "Quit"
           }
          ]
         },
         {
          "type": "text",
          "name": "packs-a-day",
          "visibleIf": "{cigarettes} = 'yes'",
          "title": "How many packs a day?",
          "inputType": "number",
          "min": 0
         },
         {
          "type": "panel",
          "name": "smoking-history",
          "elements": [
           {
            "type": "text",
            "name": "date-quit",
            "title": "Date quit",
            "titleLocation": "left",
            "inputType": "date",
            "maxValueExpression": "today()"
           },
           {
            "type": "text",
            "name": "years-smoked",
            "title": "Years smoked",
            "titleLocation": "left",
            "inputType": "number",
            "min": 0
           }
          ],
          "visibleIf": "{cigarettes} = 'quit'"
         },
         {
          "type": "boolean",
          "name": "vape",
          "title": "Do you vape (e-cigarettes)?"
         }
        ]
       },
       {
        "type": "panel",
        "name": "alcohol-use-history",
        "elements": [
         {
          "type": "boolean",
          "name": "alcohol",
          "title": "Do you drink alcohol?"
         },
         {
          "type": "text",
          "name": "drinks-per-week",
          "visibleIf": "{alcohol} = true",
          "title": "How many drinks per week?"
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "drug-use-history",
        "elements": [
         {
          "type": "checkbox",
          "name": "recreational-drugs",
          "title": "Do you use recreational drugs?",
          "choices": [
           {
            "value": "rarely",
            "text": "Rarely"
           },
           {
            "value": "marijuana",
            "text": "Marijuana"
           },
           {
            "value": "cocaine",
            "text": "Cocaine"
           },
           {
            "value": "opioids",
            "text": "Opioids"
           }
          ],
          "showOtherItem": true,
          "showNoneItem": true,
          "otherPlaceholder": "Please specify... ",
          "noneText": "Never",
          "otherText": "Other",
          "colCount": 3
         },
         {
          "type": "text",
          "name": "drug-use-times-per-month",
          "visibleIf": "{recreational-drugs} anyof ['rarely', 'marijuana', 'cocaine', 'opioids', 'other']",
          "title": "How many times per month",
          "description": "If you take different types of drugs, please specify the frequency of use for each in a 'drug - # times/month' format."
         }
        ]
       },
       {
        "type": "panel",
        "name": "personal-info",
        "elements": [
         {
          "type": "dropdown",
          "name": "education",
          "title": "What is your highest level of education completed?",
          "choices": [
           {
            "value": "high-school",
            "text": "High School"
           },
           {
            "value": "trade-school",
            "text": "Trade School"
           },
           {
            "value": "college",
            "text": "College"
           },
           {
            "value": "post-graduate",
            "text": "Post-graduate degree(s)"
           }
          ]
         },
         {
          "type": "dropdown",
          "name": "marital-status",
          "title": "What is your marital status?",
          "choices": [
           {
            "value": "married",
            "text": "Married"
           },
           {
            "value": "partnership",
            "text": "Partnership"
           },
           {
            "value": "divorced",
            "text": "Divorced"
           },
           {
            "value": "separated",
            "text": "Separated"
           },
           {
            "value": "single",
            "text": "Single"
           },
           {
            "value": "widow",
            "text": "Widow(er)"
           }
          ]
         },
         {
          "type": "panel",
          "name": "sexual-life",
          "elements": [
           {
            "type": "boolean",
            "name": "sexually-active",
            "title": "Are you sexually active?"
           },
           {
            "type": "text",
            "name": "sexual-partners-number",
            "title": "How many sexual partners do you have?",
            "inputType": "number",
            "min": 0
           },
           {
            "type": "radiogroup",
            "name": "sexual-partners-gender",
            "titleLocation": "hidden",
            "choices": [
             {
              "value": "men",
              "text": "Men"
             },
             {
              "value": "women",
              "text": "Women"
             },
             {
              "value": "both",
              "text": "Both"
             }
            ],
            "colCount": 3
           },
           {
            "type": "radiogroup",
            "name": "contraception",
            "title": "Do you use contraception?",
            "showCommentArea": true,
            "commentText": "If yes, what method?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ]
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "employment-exercises-children",
        "elements": [
         {
          "type": "radiogroup",
          "name": "employment",
          "title": "Are you employed?",
          "showCommentArea": true,
          "commentText": "Type of work",
          "choices": [
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "no",
            "text": "No"
           },
           {
            "value": "retired",
            "text": "Retired"
           }
          ],
          "colCount": 3
         },
         {
          "type": "panel",
          "name": "physical-activity",
          "elements": [
           {
            "type": "radiogroup",
            "name": "do-exercise",
            "title": "Do you exercise?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ],
            "colCount": 2
           },
           {
            "type": "multipletext",
            "name": "activities",
            "visibleIf": "{do-exercise} = 'yes'",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "activity-type",
              "title": "Type of activity"
             },
             {
              "name": "activity-frequency",
              "title": "How often"
             },
             {
              "name": "activity-duration",
              "title": "How long per activity"
             }
            ]
           }
          ]
         },
         {
          "type": "panel",
          "name": "children",
          "elements": [
           {
            "type": "boolean",
            "name": "have-children",
            "title": "Do you have children?"
           },
           {
            "type": "multipletext",
            "name": "children-ages",
            "visibleIf": "{have-children} = true",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "children-number",
              "title": "# of children"
             },
             {
              "name": "ages",
              "title": "Their ages"
             }
            ]
           }
          ]
         }
        ],
        "startWithNewLine": false
       }
      ]
     }
    ],
    "title": "Social history"
   },
   {
    "name": "Surgical history / recent hospitalizations",
    "elements": [
     {
      "type": "comment",
      "name": "surgery-description",
      "title": "Date and type of surgery / procedure"
     }
    ],
    "title": "Surgical history / recent hospitalizations"
   },
   {
    "name": "Family history",
    "elements": [
     {
      "type": "matrixdynamic",
      "name": "family-history",
      "titleLocation": "hidden",
      "columns": [
       {
        "name": "relation",
        "title": "Relation"
       },
       {
        "name": "health-conditions",
        "title": "Health conditions"
       },
       {
        "name": "cancer-history",
        "title": "Family history of cancer"
       }
      ],
      "cellType": "text"
     }
    ],
    "title": "Family history"
   },
   {
    "name": "Preventive care",
    "elements": [
     {
      "type": "panel",
      "name": "preventive-care",
      "elements": [
       {
        "type": "panel",
        "name": "recent-shots-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-shots",
          "title": "Recent shots from a doctor or pharmacist",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "flu",
            "text": "Flu"
           },
           {
            "value": "shingles",
            "text": "Shingles"
           },
           {
            "value": "pneumonia",
            "text": "Pneumonia"
           },
           {
            "value": "tetanus",
            "text": "Tetanus"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "recent-tests-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-tests",
          "title": "Recent tests or procedures",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "colonoscopy",
            "text": "Colonoscopy"
           },
           {
            "value": "cologuard",
            "text": "Cologuard"
           },
           {
            "value": "mammogram",
            "text": "Mammogram"
           },
           {
            "value": "pap",
            "text": "PAP"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "specialists-panel",
        "elements": [
         {
          "type": "matrixdynamic",
          "name": "specialists",
          "title": "Specialists",
          "columns": [
           {
            "name": "provider",
            "title": "Provider's first and last name"
           },
           {
            "name": "speciality",
            "title": "Speciality"
           },
           {
            "name": "city",
            "title": "Town/City"
           }
          ],
          "cellType": "text",
          "rowCount": 1
         }
        ]
       },
       {
        "type": "panel",
        "name": "medications-and-allergies",
        "elements": [
         {
          "type": "multipletext",
          "name": "medications",
          "title": "Medications",
          "items": [
           {
            "name": "medication-name",
            "title": "Name"
           },
           {
            "name": "medication-dose",
            "title": "Dose"
           },
           {
            "name": "medication-times-per-day",
            "title": "Times per day"
           }
          ]
         },
         {
          "type": "multipletext",
          "name": "allergies",
          "startWithNewLine": false,
          "title": "Allergies",
          "items": [
           {
            "name": "allergy-type",
            "title": "Type"
           },
           {
            "name": "allergy-reaction",
            "title": "Reaction"
           }
          ]
         }
        ]
       }
      ]
     }
    ],
    "title": "Preventive care"
   },
   {
    "name": "Symptoms",
    "elements": [
     {
      "type": "tagbox",
      "name": "symptoms",
      "title": "Please select any symptoms you have now or have had in the past month.",
      "choices": [
       "Fever",
       "Chills",
       "Feeling poorly",
       "Feeling tired",
       "Weight gain",
       "Weight loss",
       "Chest pain",
       "Heart pounding",
       "Fast pulse",
       "Slow pulse",
       "Leg pain with exercise",
       "Leg swelling",
       "Joint pain",
       "Neck pain",
       "Joint swelling",
       "Joint stiffness",
       "Muscle aches",
       "Back pain",
       "Sores",
       "Rash",
       "Itching",
       "Change in a mole",
       "Unusual growth/spot"
      ]
     },
     {
      "type": "signaturepad",
      "name": "signature",
      "title": "Signature:",
      "titleLocation": "left"
     },
     {
      "type": "text",
      "name": "current-date",
      "startWithNewLine": false,
      "title": "Today's date:",
      "titleLocation": "left",
      "defaultValueExpression": "today()",
      "inputType": "date"
     }
    ],
    "title": "Symptoms"
   }
  ]
 };
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/add-custom-navigation-button/angular.md)
- [React](https://surveyjs.io/form-library/examples/add-custom-navigation-button/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/add-custom-navigation-button/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/add-custom-navigation-button/jquery.md)


---
title: Custom Navigation Buttons
product: Form Library
description: Learn how to easily add a new navigation button to a form by using the addNavigationItem() method. View a free demo for JavaScript with a ready-to-use code snippet to learn more. Customize your forms and improve user experience with SurveyJS.
framework: Angular
source: https://surveyjs.io/form-library/examples/add-custom-navigation-button/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Custom Navigation Buttons (Angular)

A survey displays a set of navigation buttons for respondents to start and end the survey, switch between survey pages, or preview answers. This example demonstrates how to add a custom navigation button that performs any required action.

## Configure a Custom Navigation Button

To add a custom button to your survey, call the [`addNavigationItem`](/form-library/documentation/api-reference/survey-data-model#addNavigationItem) method on a [`SurveyModel`](/form-library/documentation/api-reference/survey-data-model) instance. This method accepts an [`IAction`](/form-library/documentation/api-reference/iaction) object whose properties configure the button. Assign a unique string value to the [`id`](/form-library/documentation/api-reference/iaction#id) property and a button caption to the [`title`](/form-library/documentation/api-reference/iaction#title) property. Use the [`action`](/form-library/documentation/api-reference/iaction#action) property to specify the function this button should execute. This demo adds a custom "Clear Page" button that clears question values on the current page.

## Position a Custom Navigation Button

Navigation buttons are ordered according to their [`visibleIndex`](/form-library/documentation/api-reference/iaction#visibleIndex) values. The following table lists the `visibleIndex` values of built-in buttons:

| Navigation Button | `visibleIndex` |
| ----------------- | -------------- |
| Start | 10 |
| Previous Page | 20 |
| Next Page | 30 |
| Preview | 40 |
| Complete | 50 |

To insert a custom button before, after, or between two other buttons, assign a corresponding `visibleIndex` value to this button. If you do not specify `visibleIndex`, your button will be added to the end.

You can also position a button using CSS. Navigation controls are `<button>` elements wrapped in `<div>` elements. Create a CSS class that positions the `<div>` the way you need and assign the class name to the [`css`](/form-library/documentation/api-reference/iaction#css) property of the `IAction` object when you add the button. In this demo, the "Clear Page" button is aligned to the left using the `.nav-button-div` CSS class.

## Customize Button Appearance Using CSS

To style a custom button, define one or more CSS classes for the inner `<button>` element. The button also contains a nested `<span>` element for its label text. Assign one or more space-separated class names to the [`innerCss`](/form-library/documentation/api-reference/iaction#innerCss) property of the `IAction` object.

This demo shows how to override background and font colors for a custom button in normal and hover states.

## Localize the Button Text

Localization allows you to translate a custom button's caption to different languages. To localize the button text, you need to get objects with translations for each target locale and add a custom property to them. This property should contain a button caption for a specific locale. To apply the translations, assign the custom property's name to the `locTitleName` property of the `IAction` object. Make sure not to specify the `title` property in this case. Refer to the commented-out lines in the code listing for an example.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "Patient Assessment Form",
  "pages": [
   {
    "name": "Patient information",
    "elements": [
     {
      "type": "panel",
      "name": "patient-information",
      "elements": [
       {
        "type": "text",
        "name": "first-name",
        "title": "First name"
       },
       {
        "type": "text",
        "name": "last-name",
        "startWithNewLine": false,
        "title": "Last name"
       },
       {
        "type": "text",
        "name": "ssn",
        "title": "Social Security number",
        "requiredErrorText": "You SSN must be a 9-digit number.",
        "validators": [
         {
          "type": "regex",
          "text": "Your SSN must be a 9-digit number",
          "regex": "^(?!0{3})(?!6{3})[0-8]\\d{2}-?(?!0{2})\\d{2}-?(?!0{4})\\d{4}$"
         }
        ],
        "maxLength": 9
       },
       {
        "type": "text",
        "name": "birthdate",
        "startWithNewLine": false,
        "title": "Date of birth",
        "inputType": "date",
        "maxValueExpression": "today()"
       },
       {
        "type": "text",
        "name": "concerns",
        "title": "List any concerns you want to talk about during your visit"
       }
      ]
     }
    ],
    "title": "Patient information"
   },
   {
    "name": "Health history",
    "elements": [
     {
      "type": "panel",
      "name": "health-history",
      "elements": [
       {
        "type": "boolean",
        "name": "diabetes",
        "startWithNewLine": false,
        "title": "Do you have diabetes?"
       },
       {
        "type": "boolean",
        "name": "high-blood-pressure",
        "startWithNewLine": false,
        "title": "High blood pressure?"
       },
       {
        "type": "boolean",
        "name": "high-cholesterol",
        "startWithNewLine": false,
        "title": "High cholesterol?"
       },
       {
        "type": "comment",
        "name": "other-health-conditions",
        "title": "Do you have other health conditions?",
        "maxLength": 300
       }
      ]
     }
    ],
    "title": "Health history"
   },
   {
    "name": "Social history",
    "elements": [
     {
      "type": "panel",
      "name": "social-history",
      "elements": [
       {
        "type": "panel",
        "name": "smoking",
        "elements": [
         {
          "type": "radiogroup",
          "name": "cigarettes",
          "title": "Do you smoke cigarettes?",
          "choices": [
           {
            "value": "never",
            "text": "Never"
           },
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "quit",
            "text": "Quit"
           }
          ]
         },
         {
          "type": "text",
          "name": "packs-a-day",
          "visibleIf": "{cigarettes} = 'yes'",
          "title": "How many packs a day?",
          "inputType": "number",
          "min": 0
         },
         {
          "type": "panel",
          "name": "smoking-history",
          "elements": [
           {
            "type": "text",
            "name": "date-quit",
            "title": "Date quit",
            "titleLocation": "left",
            "inputType": "date",
            "maxValueExpression": "today()"
           },
           {
            "type": "text",
            "name": "years-smoked",
            "title": "Years smoked",
            "titleLocation": "left",
            "inputType": "number",
            "min": 0
           }
          ],
          "visibleIf": "{cigarettes} = 'quit'"
         },
         {
          "type": "boolean",
          "name": "vape",
          "title": "Do you vape (e-cigarettes)?"
         }
        ]
       },
       {
        "type": "panel",
        "name": "alcohol-use-history",
        "elements": [
         {
          "type": "boolean",
          "name": "alcohol",
          "title": "Do you drink alcohol?"
         },
         {
          "type": "text",
          "name": "drinks-per-week",
          "visibleIf": "{alcohol} = true",
          "title": "How many drinks per week?"
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "drug-use-history",
        "elements": [
         {
          "type": "checkbox",
          "name": "recreational-drugs",
          "title": "Do you use recreational drugs?",
          "choices": [
           {
            "value": "rarely",
            "text": "Rarely"
           },
           {
            "value": "marijuana",
            "text": "Marijuana"
           },
           {
            "value": "cocaine",
            "text": "Cocaine"
           },
           {
            "value": "opioids",
            "text": "Opioids"
           }
          ],
          "showOtherItem": true,
          "showNoneItem": true,
          "otherPlaceholder": "Please specify... ",
          "noneText": "Never",
          "otherText": "Other",
          "colCount": 3
         },
         {
          "type": "text",
          "name": "drug-use-times-per-month",
          "visibleIf": "{recreational-drugs} anyof ['rarely', 'marijuana', 'cocaine', 'opioids', 'other']",
          "title": "How many times per month",
          "description": "If you take different types of drugs, please specify the frequency of use for each in a 'drug - # times/month' format."
         }
        ]
       },
       {
        "type": "panel",
        "name": "personal-info",
        "elements": [
         {
          "type": "dropdown",
          "name": "education",
          "title": "What is your highest level of education completed?",
          "choices": [
           {
            "value": "high-school",
            "text": "High School"
           },
           {
            "value": "trade-school",
            "text": "Trade School"
           },
           {
            "value": "college",
            "text": "College"
           },
           {
            "value": "post-graduate",
            "text": "Post-graduate degree(s)"
           }
          ]
         },
         {
          "type": "dropdown",
          "name": "marital-status",
          "title": "What is your marital status?",
          "choices": [
           {
            "value": "married",
            "text": "Married"
           },
           {
            "value": "partnership",
            "text": "Partnership"
           },
           {
            "value": "divorced",
            "text": "Divorced"
           },
           {
            "value": "separated",
            "text": "Separated"
           },
           {
            "value": "single",
            "text": "Single"
           },
           {
            "value": "widow",
            "text": "Widow(er)"
           }
          ]
         },
         {
          "type": "panel",
          "name": "sexual-life",
          "elements": [
           {
            "type": "boolean",
            "name": "sexually-active",
            "title": "Are you sexually active?"
           },
           {
            "type": "text",
            "name": "sexual-partners-number",
            "title": "How many sexual partners do you have?",
            "inputType": "number",
            "min": 0
           },
           {
            "type": "radiogroup",
            "name": "sexual-partners-gender",
            "titleLocation": "hidden",
            "choices": [
             {
              "value": "men",
              "text": "Men"
             },
             {
              "value": "women",
              "text": "Women"
             },
             {
              "value": "both",
              "text": "Both"
             }
            ],
            "colCount": 3
           },
           {
            "type": "radiogroup",
            "name": "contraception",
            "title": "Do you use contraception?",
            "showCommentArea": true,
            "commentText": "If yes, what method?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ]
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "employment-exercises-children",
        "elements": [
         {
          "type": "radiogroup",
          "name": "employment",
          "title": "Are you employed?",
          "showCommentArea": true,
          "commentText": "Type of work",
          "choices": [
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "no",
            "text": "No"
           },
           {
            "value": "retired",
            "text": "Retired"
           }
          ],
          "colCount": 3
         },
         {
          "type": "panel",
          "name": "physical-activity",
          "elements": [
           {
            "type": "radiogroup",
            "name": "do-exercise",
            "title": "Do you exercise?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ],
            "colCount": 2
           },
           {
            "type": "multipletext",
            "name": "activities",
            "visibleIf": "{do-exercise} = 'yes'",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "activity-type",
              "title": "Type of activity"
             },
             {
              "name": "activity-frequency",
              "title": "How often"
             },
             {
              "name": "activity-duration",
              "title": "How long per activity"
             }
            ]
           }
          ]
         },
         {
          "type": "panel",
          "name": "children",
          "elements": [
           {
            "type": "boolean",
            "name": "have-children",
            "title": "Do you have children?"
           },
           {
            "type": "multipletext",
            "name": "children-ages",
            "visibleIf": "{have-children} = true",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "children-number",
              "title": "# of children"
             },
             {
              "name": "ages",
              "title": "Their ages"
             }
            ]
           }
          ]
         }
        ],
        "startWithNewLine": false
       }
      ]
     }
    ],
    "title": "Social history"
   },
   {
    "name": "Surgical history / recent hospitalizations",
    "elements": [
     {
      "type": "comment",
      "name": "surgery-description",
      "title": "Date and type of surgery / procedure"
     }
    ],
    "title": "Surgical history / recent hospitalizations"
   },
   {
    "name": "Family history",
    "elements": [
     {
      "type": "matrixdynamic",
      "name": "family-history",
      "titleLocation": "hidden",
      "columns": [
       {
        "name": "relation",
        "title": "Relation"
       },
       {
        "name": "health-conditions",
        "title": "Health conditions"
       },
       {
        "name": "cancer-history",
        "title": "Family history of cancer"
       }
      ],
      "cellType": "text"
     }
    ],
    "title": "Family history"
   },
   {
    "name": "Preventive care",
    "elements": [
     {
      "type": "panel",
      "name": "preventive-care",
      "elements": [
       {
        "type": "panel",
        "name": "recent-shots-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-shots",
          "title": "Recent shots from a doctor or pharmacist",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "flu",
            "text": "Flu"
           },
           {
            "value": "shingles",
            "text": "Shingles"
           },
           {
            "value": "pneumonia",
            "text": "Pneumonia"
           },
           {
            "value": "tetanus",
            "text": "Tetanus"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "recent-tests-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-tests",
          "title": "Recent tests or procedures",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "colonoscopy",
            "text": "Colonoscopy"
           },
           {
            "value": "cologuard",
            "text": "Cologuard"
           },
           {
            "value": "mammogram",
            "text": "Mammogram"
           },
           {
            "value": "pap",
            "text": "PAP"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "specialists-panel",
        "elements": [
         {
          "type": "matrixdynamic",
          "name": "specialists",
          "title": "Specialists",
          "columns": [
           {
            "name": "provider",
            "title": "Provider's first and last name"
           },
           {
            "name": "speciality",
            "title": "Speciality"
           },
           {
            "name": "city",
            "title": "Town/City"
           }
          ],
          "cellType": "text",
          "rowCount": 1
         }
        ]
       },
       {
        "type": "panel",
        "name": "medications-and-allergies",
        "elements": [
         {
          "type": "multipletext",
          "name": "medications",
          "title": "Medications",
          "items": [
           {
            "name": "medication-name",
            "title": "Name"
           },
           {
            "name": "medication-dose",
            "title": "Dose"
           },
           {
            "name": "medication-times-per-day",
            "title": "Times per day"
           }
          ]
         },
         {
          "type": "multipletext",
          "name": "allergies",
          "startWithNewLine": false,
          "title": "Allergies",
          "items": [
           {
            "name": "allergy-type",
            "title": "Type"
           },
           {
            "name": "allergy-reaction",
            "title": "Reaction"
           }
          ]
         }
        ]
       }
      ]
     }
    ],
    "title": "Preventive care"
   },
   {
    "name": "Symptoms",
    "elements": [
     {
      "type": "tagbox",
      "name": "symptoms",
      "title": "Please select any symptoms you have now or have had in the past month.",
      "choices": [
       "Fever",
       "Chills",
       "Feeling poorly",
       "Feeling tired",
       "Weight gain",
       "Weight loss",
       "Chest pain",
       "Heart pounding",
       "Fast pulse",
       "Slow pulse",
       "Leg pain with exercise",
       "Leg swelling",
       "Joint pain",
       "Neck pain",
       "Joint swelling",
       "Joint stiffness",
       "Muscle aches",
       "Back pain",
       "Sores",
       "Rash",
       "Itching",
       "Change in a mole",
       "Unusual growth/spot"
      ]
     },
     {
      "type": "signaturepad",
      "name": "signature",
      "title": "Signature:",
      "titleLocation": "left"
     },
     {
      "type": "text",
      "name": "current-date",
      "startWithNewLine": false,
      "title": "Today's date:",
      "titleLocation": "left",
      "defaultValueExpression": "today()",
      "inputType": "date"
     }
    ],
    "title": "Symptoms"
   }
  ]
 };
```

### `src/app/components/survey.component.css`

```css
.nav-button-div {
    margin-left: auto; 
    margin-right: 0;
}

.nav-button {
    background-color: #ff9814;
}

.nav-button:hover {
    background-color: #f28a05;
}

.nav-button span,
.nav-button:hover span {
  color: #ffffff;
}
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";
// Uncomment the following line if you want to localize the custom button text 
//import { getLocaleStrings } from "survey-core";
//import "survey-core/survey.i18n";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        // Uncomment the following lines if you want to localize the custom button text 
        // const enTranslations = getLocaleStrings("en");
        // const frTranslations = getLocaleStrings("fr");
        // enTranslations.clearPage = "Clear Page";
        // frTranslations.clearPage = "Effacer la page";
        
        survey.addNavigationItem({
            id: "sv-nav-clear-page",
            // To set the button text, use the `title` property  if you don't use localization:
            title: "Clear Page",
            // ... or the `locTitleName` property if you do use localization:
            // locTitleName: "clearPage",
            action: () => {
                survey.currentPage.questions.forEach((question) => {
                    question.value = undefined;
                });
            },
            css: "nav-button-div",
            innerCss: "nav-button"
        });
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
.nav-button-div {
    margin-left: auto; 
    margin-right: 0;
}

.nav-button {
    background-color: #ff9814;
}

.nav-button:hover {
    background-color: #f28a05;
}

.nav-button span,
.nav-button:hover span {
  color: #ffffff;
}
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/add-custom-navigation-button/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/add-custom-navigation-button/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/add-custom-navigation-button/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/add-custom-navigation-button/vanillajs.md)


---
title: Custom Navigation Buttons
product: Form Library
description: Learn how to easily add a new navigation button to a form by using the addNavigationItem() method. View a free demo for JavaScript with a ready-to-use code snippet to learn more. Customize your forms and improve user experience with SurveyJS.
framework: React
source: https://surveyjs.io/form-library/examples/add-custom-navigation-button/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Custom Navigation Buttons (React)

A survey displays a set of navigation buttons for respondents to start and end the survey, switch between survey pages, or preview answers. This example demonstrates how to add a custom navigation button that performs any required action.

## Configure a Custom Navigation Button

To add a custom button to your survey, call the [`addNavigationItem`](/form-library/documentation/api-reference/survey-data-model#addNavigationItem) method on a [`SurveyModel`](/form-library/documentation/api-reference/survey-data-model) instance. This method accepts an [`IAction`](/form-library/documentation/api-reference/iaction) object whose properties configure the button. Assign a unique string value to the [`id`](/form-library/documentation/api-reference/iaction#id) property and a button caption to the [`title`](/form-library/documentation/api-reference/iaction#title) property. Use the [`action`](/form-library/documentation/api-reference/iaction#action) property to specify the function this button should execute. This demo adds a custom "Clear Page" button that clears question values on the current page.

## Position a Custom Navigation Button

Navigation buttons are ordered according to their [`visibleIndex`](/form-library/documentation/api-reference/iaction#visibleIndex) values. The following table lists the `visibleIndex` values of built-in buttons:

| Navigation Button | `visibleIndex` |
| ----------------- | -------------- |
| Start | 10 |
| Previous Page | 20 |
| Next Page | 30 |
| Preview | 40 |
| Complete | 50 |

To insert a custom button before, after, or between two other buttons, assign a corresponding `visibleIndex` value to this button. If you do not specify `visibleIndex`, your button will be added to the end.

You can also position a button using CSS. Navigation controls are `<button>` elements wrapped in `<div>` elements. Create a CSS class that positions the `<div>` the way you need and assign the class name to the [`css`](/form-library/documentation/api-reference/iaction#css) property of the `IAction` object when you add the button. In this demo, the "Clear Page" button is aligned to the left using the `.nav-button-div` CSS class.

## Customize Button Appearance Using CSS

To style a custom button, define one or more CSS classes for the inner `<button>` element. The button also contains a nested `<span>` element for its label text. Assign one or more space-separated class names to the [`innerCss`](/form-library/documentation/api-reference/iaction#innerCss) property of the `IAction` object.

This demo shows how to override background and font colors for a custom button in normal and hover states.

## Localize the Button Text

Localization allows you to translate a custom button's caption to different languages. To localize the button text, you need to get objects with translations for each target locale and add a custom property to them. This property should contain a button caption for a specific locale. To apply the translations, assign the custom property's name to the `locTitleName` property of the `IAction` object. Make sure not to specify the `title` property in this case. Refer to the commented-out lines in the code listing for an example.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
// Uncomment the following line if you want to localize the custom button text 
//import { getLocaleStrings } from "survey-core";
//import "survey-core/survey.i18n";

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    // Uncomment the following lines if you want to localize the custom button text 
    // const enTranslations = getLocaleStrings("en");
    // const frTranslations = getLocaleStrings("fr");
    // enTranslations.clearPage = "Clear Page";
    // frTranslations.clearPage = "Effacer la page";
    
    survey.addNavigationItem({
        id: "sv-nav-clear-page",
        // To set the button text, use the `title` property  if you don't use localization:
        title: "Clear Page",
        // ... or the `locTitleName` property if you do use localization:
        // locTitleName: "clearPage",
        action: () => {
            survey.currentPage.questions.forEach((question) => {
                question.value = undefined;
            });
        },
        css: "nav-button-div",
        innerCss: "nav-button"
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
.nav-button-div {
    margin-left: auto; 
    margin-right: 0;
}

.nav-button {
    background-color: #ff9814;
}

.nav-button:hover {
    background-color: #f28a05;
}

.nav-button span,
.nav-button:hover span {
  color: #ffffff;
}
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "Patient Assessment Form",
  "pages": [
   {
    "name": "Patient information",
    "elements": [
     {
      "type": "panel",
      "name": "patient-information",
      "elements": [
       {
        "type": "text",
        "name": "first-name",
        "title": "First name"
       },
       {
        "type": "text",
        "name": "last-name",
        "startWithNewLine": false,
        "title": "Last name"
       },
       {
        "type": "text",
        "name": "ssn",
        "title": "Social Security number",
        "requiredErrorText": "You SSN must be a 9-digit number.",
        "validators": [
         {
          "type": "regex",
          "text": "Your SSN must be a 9-digit number",
          "regex": "^(?!0{3})(?!6{3})[0-8]\\d{2}-?(?!0{2})\\d{2}-?(?!0{4})\\d{4}$"
         }
        ],
        "maxLength": 9
       },
       {
        "type": "text",
        "name": "birthdate",
        "startWithNewLine": false,
        "title": "Date of birth",
        "inputType": "date",
        "maxValueExpression": "today()"
       },
       {
        "type": "text",
        "name": "concerns",
        "title": "List any concerns you want to talk about during your visit"
       }
      ]
     }
    ],
    "title": "Patient information"
   },
   {
    "name": "Health history",
    "elements": [
     {
      "type": "panel",
      "name": "health-history",
      "elements": [
       {
        "type": "boolean",
        "name": "diabetes",
        "startWithNewLine": false,
        "title": "Do you have diabetes?"
       },
       {
        "type": "boolean",
        "name": "high-blood-pressure",
        "startWithNewLine": false,
        "title": "High blood pressure?"
       },
       {
        "type": "boolean",
        "name": "high-cholesterol",
        "startWithNewLine": false,
        "title": "High cholesterol?"
       },
       {
        "type": "comment",
        "name": "other-health-conditions",
        "title": "Do you have other health conditions?",
        "maxLength": 300
       }
      ]
     }
    ],
    "title": "Health history"
   },
   {
    "name": "Social history",
    "elements": [
     {
      "type": "panel",
      "name": "social-history",
      "elements": [
       {
        "type": "panel",
        "name": "smoking",
        "elements": [
         {
          "type": "radiogroup",
          "name": "cigarettes",
          "title": "Do you smoke cigarettes?",
          "choices": [
           {
            "value": "never",
            "text": "Never"
           },
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "quit",
            "text": "Quit"
           }
          ]
         },
         {
          "type": "text",
          "name": "packs-a-day",
          "visibleIf": "{cigarettes} = 'yes'",
          "title": "How many packs a day?",
          "inputType": "number",
          "min": 0
         },
         {
          "type": "panel",
          "name": "smoking-history",
          "elements": [
           {
            "type": "text",
            "name": "date-quit",
            "title": "Date quit",
            "titleLocation": "left",
            "inputType": "date",
            "maxValueExpression": "today()"
           },
           {
            "type": "text",
            "name": "years-smoked",
            "title": "Years smoked",
            "titleLocation": "left",
            "inputType": "number",
            "min": 0
           }
          ],
          "visibleIf": "{cigarettes} = 'quit'"
         },
         {
          "type": "boolean",
          "name": "vape",
          "title": "Do you vape (e-cigarettes)?"
         }
        ]
       },
       {
        "type": "panel",
        "name": "alcohol-use-history",
        "elements": [
         {
          "type": "boolean",
          "name": "alcohol",
          "title": "Do you drink alcohol?"
         },
         {
          "type": "text",
          "name": "drinks-per-week",
          "visibleIf": "{alcohol} = true",
          "title": "How many drinks per week?"
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "drug-use-history",
        "elements": [
         {
          "type": "checkbox",
          "name": "recreational-drugs",
          "title": "Do you use recreational drugs?",
          "choices": [
           {
            "value": "rarely",
            "text": "Rarely"
           },
           {
            "value": "marijuana",
            "text": "Marijuana"
           },
           {
            "value": "cocaine",
            "text": "Cocaine"
           },
           {
            "value": "opioids",
            "text": "Opioids"
           }
          ],
          "showOtherItem": true,
          "showNoneItem": true,
          "otherPlaceholder": "Please specify... ",
          "noneText": "Never",
          "otherText": "Other",
          "colCount": 3
         },
         {
          "type": "text",
          "name": "drug-use-times-per-month",
          "visibleIf": "{recreational-drugs} anyof ['rarely', 'marijuana', 'cocaine', 'opioids', 'other']",
          "title": "How many times per month",
          "description": "If you take different types of drugs, please specify the frequency of use for each in a 'drug - # times/month' format."
         }
        ]
       },
       {
        "type": "panel",
        "name": "personal-info",
        "elements": [
         {
          "type": "dropdown",
          "name": "education",
          "title": "What is your highest level of education completed?",
          "choices": [
           {
            "value": "high-school",
            "text": "High School"
           },
           {
            "value": "trade-school",
            "text": "Trade School"
           },
           {
            "value": "college",
            "text": "College"
           },
           {
            "value": "post-graduate",
            "text": "Post-graduate degree(s)"
           }
          ]
         },
         {
          "type": "dropdown",
          "name": "marital-status",
          "title": "What is your marital status?",
          "choices": [
           {
            "value": "married",
            "text": "Married"
           },
           {
            "value": "partnership",
            "text": "Partnership"
           },
           {
            "value": "divorced",
            "text": "Divorced"
           },
           {
            "value": "separated",
            "text": "Separated"
           },
           {
            "value": "single",
            "text": "Single"
           },
           {
            "value": "widow",
            "text": "Widow(er)"
           }
          ]
         },
         {
          "type": "panel",
          "name": "sexual-life",
          "elements": [
           {
            "type": "boolean",
            "name": "sexually-active",
            "title": "Are you sexually active?"
           },
           {
            "type": "text",
            "name": "sexual-partners-number",
            "title": "How many sexual partners do you have?",
            "inputType": "number",
            "min": 0
           },
           {
            "type": "radiogroup",
            "name": "sexual-partners-gender",
            "titleLocation": "hidden",
            "choices": [
             {
              "value": "men",
              "text": "Men"
             },
             {
              "value": "women",
              "text": "Women"
             },
             {
              "value": "both",
              "text": "Both"
             }
            ],
            "colCount": 3
           },
           {
            "type": "radiogroup",
            "name": "contraception",
            "title": "Do you use contraception?",
            "showCommentArea": true,
            "commentText": "If yes, what method?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ]
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "employment-exercises-children",
        "elements": [
         {
          "type": "radiogroup",
          "name": "employment",
          "title": "Are you employed?",
          "showCommentArea": true,
          "commentText": "Type of work",
          "choices": [
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "no",
            "text": "No"
           },
           {
            "value": "retired",
            "text": "Retired"
           }
          ],
          "colCount": 3
         },
         {
          "type": "panel",
          "name": "physical-activity",
          "elements": [
           {
            "type": "radiogroup",
            "name": "do-exercise",
            "title": "Do you exercise?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ],
            "colCount": 2
           },
           {
            "type": "multipletext",
            "name": "activities",
            "visibleIf": "{do-exercise} = 'yes'",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "activity-type",
              "title": "Type of activity"
             },
             {
              "name": "activity-frequency",
              "title": "How often"
             },
             {
              "name": "activity-duration",
              "title": "How long per activity"
             }
            ]
           }
          ]
         },
         {
          "type": "panel",
          "name": "children",
          "elements": [
           {
            "type": "boolean",
            "name": "have-children",
            "title": "Do you have children?"
           },
           {
            "type": "multipletext",
            "name": "children-ages",
            "visibleIf": "{have-children} = true",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "children-number",
              "title": "# of children"
             },
             {
              "name": "ages",
              "title": "Their ages"
             }
            ]
           }
          ]
         }
        ],
        "startWithNewLine": false
       }
      ]
     }
    ],
    "title": "Social history"
   },
   {
    "name": "Surgical history / recent hospitalizations",
    "elements": [
     {
      "type": "comment",
      "name": "surgery-description",
      "title": "Date and type of surgery / procedure"
     }
    ],
    "title": "Surgical history / recent hospitalizations"
   },
   {
    "name": "Family history",
    "elements": [
     {
      "type": "matrixdynamic",
      "name": "family-history",
      "titleLocation": "hidden",
      "columns": [
       {
        "name": "relation",
        "title": "Relation"
       },
       {
        "name": "health-conditions",
        "title": "Health conditions"
       },
       {
        "name": "cancer-history",
        "title": "Family history of cancer"
       }
      ],
      "cellType": "text"
     }
    ],
    "title": "Family history"
   },
   {
    "name": "Preventive care",
    "elements": [
     {
      "type": "panel",
      "name": "preventive-care",
      "elements": [
       {
        "type": "panel",
        "name": "recent-shots-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-shots",
          "title": "Recent shots from a doctor or pharmacist",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "flu",
            "text": "Flu"
           },
           {
            "value": "shingles",
            "text": "Shingles"
           },
           {
            "value": "pneumonia",
            "text": "Pneumonia"
           },
           {
            "value": "tetanus",
            "text": "Tetanus"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "recent-tests-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-tests",
          "title": "Recent tests or procedures",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "colonoscopy",
            "text": "Colonoscopy"
           },
           {
            "value": "cologuard",
            "text": "Cologuard"
           },
           {
            "value": "mammogram",
            "text": "Mammogram"
           },
           {
            "value": "pap",
            "text": "PAP"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "specialists-panel",
        "elements": [
         {
          "type": "matrixdynamic",
          "name": "specialists",
          "title": "Specialists",
          "columns": [
           {
            "name": "provider",
            "title": "Provider's first and last name"
           },
           {
            "name": "speciality",
            "title": "Speciality"
           },
           {
            "name": "city",
            "title": "Town/City"
           }
          ],
          "cellType": "text",
          "rowCount": 1
         }
        ]
       },
       {
        "type": "panel",
        "name": "medications-and-allergies",
        "elements": [
         {
          "type": "multipletext",
          "name": "medications",
          "title": "Medications",
          "items": [
           {
            "name": "medication-name",
            "title": "Name"
           },
           {
            "name": "medication-dose",
            "title": "Dose"
           },
           {
            "name": "medication-times-per-day",
            "title": "Times per day"
           }
          ]
         },
         {
          "type": "multipletext",
          "name": "allergies",
          "startWithNewLine": false,
          "title": "Allergies",
          "items": [
           {
            "name": "allergy-type",
            "title": "Type"
           },
           {
            "name": "allergy-reaction",
            "title": "Reaction"
           }
          ]
         }
        ]
       }
      ]
     }
    ],
    "title": "Preventive care"
   },
   {
    "name": "Symptoms",
    "elements": [
     {
      "type": "tagbox",
      "name": "symptoms",
      "title": "Please select any symptoms you have now or have had in the past month.",
      "choices": [
       "Fever",
       "Chills",
       "Feeling poorly",
       "Feeling tired",
       "Weight gain",
       "Weight loss",
       "Chest pain",
       "Heart pounding",
       "Fast pulse",
       "Slow pulse",
       "Leg pain with exercise",
       "Leg swelling",
       "Joint pain",
       "Neck pain",
       "Joint swelling",
       "Joint stiffness",
       "Muscle aches",
       "Back pain",
       "Sores",
       "Rash",
       "Itching",
       "Change in a mole",
       "Unusual growth/spot"
      ]
     },
     {
      "type": "signaturepad",
      "name": "signature",
      "title": "Signature:",
      "titleLocation": "left"
     },
     {
      "type": "text",
      "name": "current-date",
      "startWithNewLine": false,
      "title": "Today's date:",
      "titleLocation": "left",
      "defaultValueExpression": "today()",
      "inputType": "date"
     }
    ],
    "title": "Symptoms"
   }
  ]
 };
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/add-custom-navigation-button/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/add-custom-navigation-button/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/add-custom-navigation-button/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/add-custom-navigation-button/vanillajs.md)
